﻿using System;
using System.Collections.Generic;
using System.Text;
using Asp = System.Web;
using System.Data;

namespace Daco.Web.UI.WebControls
{
    public class ULProfile : Asp.UI.WebControls.WebControl
    {
        private DataRowCollection _dataSource = null;
        public DataRowCollection DataSource
        {
            get { return _dataSource; }
            set { _dataSource = value; }
        }

        private string _title;
        public string Title
        {
            get { return _title; }
            set
            {
                if (!string.IsNullOrEmpty(value) && (string.IsNullOrEmpty(_title) || string.Compare(value, _title, StringComparison.CurrentCultureIgnoreCase) == 0))
                    _title = value;
            }
        }

        public override string ClientID
        {
            get
            {
                return string.Format("DACO_WebControl_ProfileList_" + this.GetHashCode());
            }
        }

        public override string UniqueID
        {
            get
            {
                return string.Format("DACO$WebControl$ProfileList$" + this.GetHashCode());
            }
        }

        public ULProfile()
        {
            this.Load += new EventHandler(ULProfile_Load);
        }

        void ULProfile_Load(object sender, EventArgs e)
        {
            _dataSource = CWeb.GetProfileList();
        }

        protected override void Render(System.Web.UI.HtmlTextWriter writer)
        {
            writer.WriteLine(@"<div class=""DIVBox"">
                            <div class=""DIVBoxHeader"">
                                <div><h4>{0}</h4></div>
                            </div>
                            <div class=""DIVBoxContent"">
                                <div>", Title);
            writer.WriteLine(@"<ul class=""ULLineHeight150"">");
            foreach (DataRow row in _dataSource)
            {
                // Write begin LI
                writer.Write(@"<li class=""LISquare"">
                    <a class=""title"" href=""{0}"" title=""{1}"" >{1}</a>", Page.ResolveUrl(string.Format("~/Profile.aspx?cpid={0}", row["ID"], row["Name"])), row["Name"]);
                // Write end LI
                writer.WriteLine("</li>");
            }
            writer.WriteLine("</ul>");

            writer.WriteLine(@"</div>
                        </div>
                    </div>");
        }
    }
}
